/*
Import des librairies son
Nécessite l'installation de la librairie Minim
*/ 
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;
import ddf.minim.signals.*;
import ddf.minim.spi.*;
import ddf.minim.ugens.*;

float volume;
float seuil=5.0;
float moyenne=0;
int tampon=10;

Minim minim; //Utilisation d'un objet de la librairie Minimim
AudioInput in; // Création d'une ligne d'entrée audio
  
 void setup(){
   minim = new Minim(this);
   in = minim.getLineIn(Minim.STEREO,16);//Récupération de l'entrée son du micro 
   size(640,360);
   frameRate(30);
   stroke(255);
 }
 
void draw(){
   volume = in.mix.level()*5; // Muliplication du volume
   moyenne=((moyenne*tampon)+volume)/(tampon+1); // calcul d'une moyenne du volume pour filtrer le signal
   float vF = map(moyenne,0,seuil,0,width); //changement d'échelle de la valeur moyenne
   background(0);
   ellipse(width/2,height/2,vF,vF);//dessin de l'ellipse avec pour diamètre la valeur vF (volume sonore filtré)
 }